import urllib3
import os
import sys
import re

# python /pod/REPRISE/esup-pod-api-sample/migration/download-files-from-url.py

# ADAPT - Videos base path
base_files_path="/pod/media/files"

# ADAPT - Input file
media_files_list="/pod/REPRISE/esup-pod-api-sample/migration/media_files_list.txt"

urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)
http = urllib3.PoolManager(cert_reqs='CERT_NONE')
http_headers = urllib3.make_headers(basic_auth='julien.marchal@esup-portail.org:XXXXXX')

print("***************** USE media_files_list : %s *************"%media_files_list)

fmedia = open(media_files_list, 'r')
lines = fmedia.readlines()

for l in lines:
    l = l.strip()
    parts = re.search('^https://(.*)/media/files/(.*)/(.*)$', l, re.IGNORECASE)
    domain=parts.group(1)
    hashkey=parts.group(2)
    filename=parts.group(3)
    #print("%s - %s" % (hashkey,filename ))
    
    hashPath=base_files_path+"/"+hashkey
    outFilePath =hashPath+"/"+filename

    if not os.path.exists(hashPath):
      os.mkdir(hashPath)

    print("download file : %s " % (l), end="", flush=True)
    r = http.request('GET', l, headers=http_headers, preload_content=False)
    with open(outFilePath, 'wb') as out:
      while True:
          data = r.read(8192)
          if not data:
              break
          out.write(data)
          #print(".", end="", flush=True)
    r.release_conn()
    print(" DONE")

