import urllib3
import os
import sys
import re

# python /pod/REPRISE/esup-pod-api-sample/migration/download-videos-from-url.py

# ADAPT - Videos base path
base_videos_path="/pod/media/videos"

# ADAPT - Input file
media_videos_list="/pod/REPRISE/esup-pod-api-sample/migration/media_videos_list.txt"

urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)
http = urllib3.PoolManager(cert_reqs='CERT_NONE')
http_headers = urllib3.make_headers(basic_auth='julien.marchal@esup-portail.org:XXXXX')

print("***************** USE videos_files_list : %s *************"%media_videos_list)

fvideo = open(media_videos_list, 'r')
lines = fvideo.readlines()

for l in lines:
    l = l.strip()
    if re.match(r'^https://(.*)/media/videos/(.*)/(.*)/(.*)$', l):
      parts = re.search('^https://(.*)/media/videos/(.*)/(.*)/(.*)$', l, re.IGNORECASE)
      domain=parts.group(1)
      hashkey=parts.group(2)
      dirname=parts.group(3)
      filename=parts.group(4)
      #print("%s - %s - %s" % (hashkey,dirname,filename ))
      hashPath = base_videos_path+"/"+hashkey
      videoIdPath = hashPath+"/"+dirname
      outFilePath = videoIdPath+"/"+filename

      if not os.path.exists(hashPath):
        os.mkdir(hashPath)
      if not os.path.exists(videoIdPath):
        os.mkdir(videoIdPath)

    elif re.match(r'^https://(.*)/media/videos/(.*)/(.*)$', l):
      parts = re.search('^https://(.*)/media/videos/(.*)/(.*)$', l, re.IGNORECASE)
      domain=parts.group(1)
      hashkey=parts.group(2)
      filename=parts.group(3)
      #print("%s - %s" % (hashkey,filename ))
      hashPath = base_videos_path+"/"+hashkey
      outFilePath = hashPath+"/"+filename
      if not os.path.exists(hashPath):
        os.mkdir(hashPath)
  
    print("download video : %s " % (l), end="", flush=True)
    r = http.request('GET', l, headers=http_headers, preload_content=False)
    with open(outFilePath, 'wb') as out:
      while True:
          data = r.read(16384)
          if not data:
              break
          out.write(data)
          #print(".", end="", flush=True)
    r.release_conn()
    print(" DONE")