import os
import sys
import re

# python /pod/REPRISE/esup-pod-api-sample/migration/test-videos-after-download.py

# ADAPT - Videos base path
base_videos_path="/pod/media/videos"

# ADAPT - Input file
media_videos_list="/pod/REPRISE/esup-pod-api-sample/migration/media_videos_list.txt"


print("***************** USE videos_files_list : %s *************"%media_videos_list)
fvideo = open(media_videos_list, 'r')
lines = fvideo.readlines()

for l in lines:
    l = l.strip()
    if re.match(r'^https://(.*)/media/videos/(.*)/(.*)/(.*)$', l):
        parts = re.search('^https://(.*)/media/videos/(.*)/(.*)/(.*)$', l, re.IGNORECASE)
        domain=parts.group(1)
        hashkey=parts.group(2)
        dirname=parts.group(3)
        filename=parts.group(4)
        hashPath = base_videos_path+"/"+hashkey
        videoIdPath = hashPath+"/"+dirname
        testFilePath = videoIdPath+"/"+filename

        if not os.path.exists(testFilePath):
          print("File %s not exist"%testFilePath)
        elif os.stat(testFilePath).st_size == 0 :
          print("File %s emtpy"%testFilePath)

    elif re.match(r'^https://(.*)/media/videos/(.*)/(.*)$', l):
        parts = re.search('^https://(.*)/media/videos/(.*)/(.*)$', l, re.IGNORECASE)
        domain=parts.group(1)
        hashkey=parts.group(2)
        filename=parts.group(3)
        hashPath = base_videos_path+"/"+hashkey
        testFilePath = hashPath+"/"+filename
        
        if not os.path.exists(testFilePath):
          print("File %s not exist"%testFilePath)
        elif os.stat(testFilePath).st_size == 0 :
          print("File %s emtpy"%testFilePath)
